<?php
//
// Runtime Library
//

$rt_object = new rtObject;
$rt_object->object_super = '';

$rt_object->object_selectors[] = 'isBasedOnModel';
$rt_object->object_selectors[] = 'respondsToMessage';
$rt_object->object_selectors[] = 'model';
$rt_object->object_selectors[] = 'prototype';
$rt_object->object_selectors[] = 'objectname';
$rt_object->object_selectors[] = 'self';
$rt_object->object_selectors[] = 'setBinding';
$rt_object->object_selectors[] = 'removeBinding';

$rt_objects_def = array('object' => &$rt_object);
function rt_object_setBinding($rt_params=array()){
	$me = $rt_params[0];
	$super = $rt_params[1];
	
	if( empty($super) ) return;
	$ob = $rt_params[2];
	$k = $ob->object_name .'_' . $ob->object_uid;
	$me->object_bindings[$k] = &$rt_params[2];
}
function rt_object_removeBinding($rt_params=array()){
	$me = $rt_params[0];
	$super = $rt_params[1];
	
	if( empty($super) ) return;
	$ob = $rt_params[2];
	$k = $ob->object_name .'_' . $ob->object_uid;
	unset($me->object_bindings[$k]);
}
function rt_object_isBasedOnModel($rt_params=array()){
	$me = $rt_params[0];
	$super = $rt_params[1];
	
	if('object' == $rt_params[2]) return true;
	if($me->object_class == $rt_params[2]) return true;
	
	if($super->object_class != 'object'){
		$rt_params[0] = $super;
		$rt_params[1] = $super->rt_super();
		
		return rt_object_isBasedOnModel($rt_params);
	}
	return false;
}


function rt_object_respondsToMessage($rt_params=array()){
	$me = $rt_params[0];
	$super = $rt_params[1];
	
	$m = $rt_params[2];

	$b = rt_findObjectForSelector($me, $m);
	
	if(empty($b)) return false;
	//print "hasselector = true<br>";
	return true;
}
function rt_object_model($rt_params=array()){
	$me = $rt_params[0];
	$super = $rt_params[1];

	return $me->object_class;
}
function rt_object_objectname($rt_params=array()){
	$me = $rt_params[0];
	$super = $rt_params[1];
	
	return $me->object_name;
}
function rt_object_prototype($rt_params=array()){
	$me = $rt_params[0];
	$super = $rt_params[1];
	return $super->object_class;
}
function rt_object_self($rt_params=array()){
	$me = $rt_params[0];
	return $me;
}
function &rt_no($n){
		$a = new rtObject;
		$a->object_uid = 1;
		$a->object_name = $n;
		$a->object_class = 'object';
		
		return $a;
}
function &rt_nc($n, $dt){
	global $rt_objects_def;
	
	$a = new rtObject;
	$a->object_uid = 1;
	$a->object_name = $n;
	$a->object_super = $dt;
	$a->object_class = $n;
	
	$rt_objects_def[$n] = &$a;
	return $a;
}
function &rt_ni($n, $dt){
	global $rt_objects_def;
	
	$a = new rtObject;
	$a->object_uid = 1;
	$a->object_name = $n;
	$a->object_class = $dt;
	
	$sp = $rt_objects_def[$dt];
	//$a->object_super = $sp->object_class;
	
	//foreach($sp->object_selectors as $sel){
	//	$a->object_selectors[] = $sel;
	//}
	
	//$rt_objects_def[$n] = &$a;
	
	
	return $a;
}
class rtObject {
	var $object_uid;
	var $object_super = '';
	var $object_name = 'object';
	var $object_class = 'object';
	var $object_selectors = array();
	var $object_delegate = array();
	var $object_bindings = array();
	
	function rt_super(){
		global $rt_objects_def;
		
		//print "getting super of {$this->object_name}={$this->object_super}<br>";
		if( strlen($this->object_super) > 0) return $rt_objects_def[$this->object_super];
		return null;
		
	}
}

function rt_sm(){
	//send message
	global $rt_objects_def;
	$me = func_get_arg(0);
	$m = func_get_arg(1);
	
	if( strtolower($m) == 'count' ){
		return count($me);
	}elseif( strtolower($m) == 'isempty' ){
		return empty($me);
	}
		
	$cls = $rt_objects_def[$me->object_class];
	$sp = $cls->rt_super();
	//print_r($sp);
	
	$c = func_num_args();
	$param = array($me, $sp);
	for($i = 2; $i< $c; $i++){
		$param[] = func_get_arg($i);
	}
	
	$vb = array();
	foreach( $me->object_bindings as $bd){
		$x = rt_findObjectForSelectorB($bd, $m);
		if(!empty($x)){
			$vb[] = rt_relayMessage($bd, $m, $param);	
		}
	}
	
	$x = rt_findObjectForSelector($me, $m);
	if(empty($x)){
		if(count($vb) > 0) return $vb;
		return null;
	}
	
	if( in_array($m, $cls->object_selectors) ){
		$fm = 'rt_' . $cls->object_class . '_' . $m;
		//print "handled by {$me->object_class}::{$fm}\n";
		return $fm($param);
	}elseif(!empty($sp)){
		//print "sending $m() to super {$cls->object_super} of {$me->object_class}\n";
		return rt_relayMessage($sp, $m, $param);
	}else{
		return null;
	}
}
function rt_relayMessage($ob, $m, $param){
	global $rt_objects_def;

	//print_r($ob);	
	$sp = $ob->rt_super();
	$cls = $rt_objects_def[$ob->object_class];
	
	if( in_array($m, $cls->object_selectors) ){
		$fm = 'rt_' . $cls->object_class . '_' . $m;
		//print "handled by relay {$ob->object_class}::{$fm}\n";
		
		return $fm($param);
	}elseif(!empty($sp)){
		//print "sending $m() to super {$ob->object_super} of {$ob->object_class}\n";
		return rt_relayMessage($sp, $m, $param);
	}else{
		return null;
	}
}

function rt_findObjectForSelector($ob, $m){
	global $rt_objects_def;
	
	//print "<blockquote>";
	//print "rt_findObjectForSelector($ob->object_class, $m)<br>";
	//print_r($ob);
	
	$cls = $rt_objects_def[$ob->object_class];
	$sp = $cls->rt_super();
	//print_r($sp);
	//print "</blockquote>";
	if( in_array($m, $cls->object_selectors) ){
		return $ob;
	}elseif(!empty($sp)){
		return rt_findObjectForSelector($sp, $m);
	}else{
		return null;
	}
}
function rt_findObjectForSelectorB($ob, $m){
	global $rt_objects_def;
	
	//Does not look inside the object
	
	//print "<blockquote>";
	//print "rt_findObjectForSelector($ob->object_class, $m)<br>";
	//print_r($ob);
	
	$cls = $rt_objects_def[$ob->object_class];
	$sp = $cls->rt_super();
	//print_r($sp);
	//print "</blockquote>";
	if( in_array($m, $cls->object_selectors) ){
		return $ob;
	}elseif(!empty($sp) && ($sp->object_class != 'object')){
		return rt_findObjectForSelector($sp, $m);
	}else{
		return null;
	}
}

?>